VERSION 5.00
Begin VB.Form frmPalTest 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Palindrome Tester"
   ClientHeight    =   2640
   ClientLeft      =   4455
   ClientTop       =   3540
   ClientWidth     =   6585
   Icon            =   "frmPalTest.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2640
   ScaleWidth      =   6585
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   495
      Left            =   3840
      TabIndex        =   5
      Top             =   1980
      Width           =   2415
   End
   Begin VB.CommandButton cmdTest 
      Caption         =   "&Test"
      Default         =   -1  'True
      Height          =   495
      Left            =   345
      TabIndex        =   4
      Top             =   1980
      Width           =   2415
   End
   Begin VB.TextBox txtInput 
      Height          =   375
      Left            =   345
      TabIndex        =   0
      Top             =   420
      Width           =   5895
   End
   Begin VB.Label lblResults 
      BorderStyle     =   1  'Fixed Single
      Height          =   615
      Left            =   360
      TabIndex        =   3
      Top             =   1140
      Width           =   5895
   End
   Begin VB.Label Label2 
      BackStyle       =   0  'Transparent
      Caption         =   "Results:"
      Height          =   255
      Left            =   345
      TabIndex        =   2
      Top             =   900
      Width           =   5775
   End
   Begin VB.Label Label1 
      BackStyle       =   0  'Transparent
      Caption         =   "Enter a word or phrase (3 letters or more):"
      Height          =   255
      Left            =   345
      TabIndex        =   1
      Top             =   180
      Width           =   5775
   End
End
Attribute VB_Name = "frmPalTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub txtInput_GotFocus()
    With txtInput
        .SelStart = 0
        .SelLength = Len(.Text)
    End With
End Sub

Private Sub txtInput_Change()
    lblResults.Caption = ""
End Sub

Private Sub cmdTest_Click()
    
    If Len(txtInput.Text) < 3 Then
        MsgBox "Word or phrase must contain 3 or more characters.", _
               vbExclamation, _
               "Palindrome Tester"
        txtInput.SetFocus
        Exit Sub
    End If
    
    If IsPalindrome(txtInput.Text) Then
        lblResults.Caption = "'" & txtInput.Text & "' IS a palindrome."
    Else
        lblResults.Caption = "'" & txtInput.Text & "' is NOT a palindrome."
    End If

End Sub

Private Sub cmdExit_Click()
    End
End Sub

Private Function IsPalindrome(pstrTestPhrase As String) As Boolean

    Dim blnIsPalindrome As Boolean
    Dim intPosX         As Integer
    Dim intX            As Integer
    Dim intY            As Integer
    Dim strCurrChar     As String
    Dim strNewPhrase    As String

    ' Fix up the input by weeding out everything except letters and numbers
    ' and converting all letters to uppercase ...
    
    strNewPhrase = ""
    
    For intPosX = 1 To Len(pstrTestPhrase)
        strCurrChar = Mid$(pstrTestPhrase, intPosX, 1)
        If (strCurrChar >= "A" And strCurrChar <= "Z") _
        Or (strCurrChar >= "a" And strCurrChar <= "z") _
        Or (strCurrChar >= "0" And strCurrChar <= "9") Then
            strNewPhrase = strNewPhrase & strCurrChar
        End If
    Next
    
    strNewPhrase = UCase$(strNewPhrase)
    
    blnIsPalindrome = True    ' assume it's a palindrome until proven otherwise
    
    ' Initialize intY to point to the end of the string and intX to point to
    ' the beginning ...
    intY = Len(strNewPhrase)
    intX = 1
    
    ' compare characters at opposite ends of the string until we come to the middle
    Do Until intX >= intY
        If Mid$(strNewPhrase, intX, 1) = Mid$(strNewPhrase, intY, 1) Then
            intX = intX + 1
            intY = intY - 1
        Else
            blnIsPalindrome = False
            Exit Do
        End If
    Loop
    
    ' set the return value
    IsPalindrome = blnIsPalindrome
    
End Function

